/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.qsoft.rs.sincoar.model;

import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Collection;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author developer2
 */
@Entity
@Table(name="COMACO.MD_PROJECTS")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "MdProjects.findAll", query = "SELECT m FROM MdProjects m"),
    @NamedQuery(name = "MdProjects.findById", query = "SELECT m FROM MdProjects m WHERE m.id = :id"),
    @NamedQuery(name = "MdProjects.findByProjectName", query = "SELECT m FROM MdProjects m WHERE m.projectName = :projectName"),
    @NamedQuery(name = "MdProjects.findByComments", query = "SELECT m FROM MdProjects m WHERE m.comments = :comments"),
    @NamedQuery(name = "MdProjects.findBySecurityGroupId", query = "SELECT m FROM MdProjects m WHERE m.securityGroupId = :securityGroupId"),
    @NamedQuery(name = "MdProjects.findByCreatedOn", query = "SELECT m FROM MdProjects m WHERE m.createdOn = :createdOn"),
    @NamedQuery(name = "MdProjects.findByCreatedBy", query = "SELECT m FROM MdProjects m WHERE m.createdBy = :createdBy"),
    @NamedQuery(name = "MdProjects.findByLastUpdatedOn", query = "SELECT m FROM MdProjects m WHERE m.lastUpdatedOn = :lastUpdatedOn"),
    @NamedQuery(name = "MdProjects.findByLastUpdatedBy", query = "SELECT m FROM MdProjects m WHERE m.lastUpdatedBy = :lastUpdatedBy")})
public class MdProjects implements Serializable {

    private static final long serialVersionUID = 1L;
    // @Max(value=?)  @Min(value=?)//if you know range of your decimal fields consider using these annotations to enforce field validation
    @Id
    @Basic(optional = false)
    @Column(name = "ID")
    private BigDecimal id;
    @Basic(optional = false)
    @Column(name = "PROJECT_NAME")
    private String projectName;
    @Column(name = "COMMENTS")
    private String comments;
    @Basic(optional = false)
    @Column(name = "SECURITY_GROUP_ID")
    private BigInteger securityGroupId;
    @Basic(optional = false)
    @Column(name = "CREATED_ON")
    @Temporal(TemporalType.TIMESTAMP)
    private Date createdOn;
    @Column(name = "CREATED_BY")
    private String createdBy;
    @Column(name = "LAST_UPDATED_ON")
    @Temporal(TemporalType.TIMESTAMP)
    private Date lastUpdatedOn;
    @Column(name = "LAST_UPDATED_BY")
    private String lastUpdatedBy;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "projectIdFk")
    private Collection<MdConnections> mdConnectionsCollection;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "projectIdFk")
    private Collection<MigrDatatypeTransformMap> migrDatatypeTransformMapCollection;

    public MdProjects() {
    }

    public MdProjects(BigDecimal id) {
        this.id = id;
    }

    public MdProjects(BigDecimal id, String projectName, BigInteger securityGroupId, Date createdOn) {
        this.id = id;
        this.projectName = projectName;
        this.securityGroupId = securityGroupId;
        this.createdOn = createdOn;
    }

    public BigDecimal getId() {
        return id;
    }

    public void setId(BigDecimal id) {
        this.id = id;
    }

    public String getProjectName() {
        return projectName;
    }

    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }

    public String getComments() {
        return comments;
    }

    public void setComments(String comments) {
        this.comments = comments;
    }

    public BigInteger getSecurityGroupId() {
        return securityGroupId;
    }

    public void setSecurityGroupId(BigInteger securityGroupId) {
        this.securityGroupId = securityGroupId;
    }

    public Date getCreatedOn() {
        return createdOn;
    }

    public void setCreatedOn(Date createdOn) {
        this.createdOn = createdOn;
    }

    public String getCreatedBy() {
        return createdBy;
    }

    public void setCreatedBy(String createdBy) {
        this.createdBy = createdBy;
    }

    public Date getLastUpdatedOn() {
        return lastUpdatedOn;
    }

    public void setLastUpdatedOn(Date lastUpdatedOn) {
        this.lastUpdatedOn = lastUpdatedOn;
    }

    public String getLastUpdatedBy() {
        return lastUpdatedBy;
    }

    public void setLastUpdatedBy(String lastUpdatedBy) {
        this.lastUpdatedBy = lastUpdatedBy;
    }

    @XmlTransient
    public Collection<MdConnections> getMdConnectionsCollection() {
        return mdConnectionsCollection;
    }

    public void setMdConnectionsCollection(Collection<MdConnections> mdConnectionsCollection) {
        this.mdConnectionsCollection = mdConnectionsCollection;
    }

    @XmlTransient
    public Collection<MigrDatatypeTransformMap> getMigrDatatypeTransformMapCollection() {
        return migrDatatypeTransformMapCollection;
    }

    public void setMigrDatatypeTransformMapCollection(Collection<MigrDatatypeTransformMap> migrDatatypeTransformMapCollection) {
        this.migrDatatypeTransformMapCollection = migrDatatypeTransformMapCollection;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof MdProjects)) {
            return false;
        }
        MdProjects other = (MdProjects) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.qsoft.rs.sincoar.model.MdProjects[ id=" + id + " ]";
    }
    
}
